﻿Type=Class
Version=1.2
ModulesStructureVersion=1
B4i=true
@EndOfDesignText@
'Class module
Sub Class_Globals	
	Private myFTP As FTP
	Private myResult As String
	Private myAction As String
	Private myNrCommands,myCounter As Int
	Private myTimer As Timer
	Private myHud As HUD
	Private ftpStatus As String
	Private ftpJobs As List
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize (server As String,port As Int,user As String,password As String,ftppath As String,action As String)
	
' inizializzo le variabili di classe
	myAction = action
	ftpStatus = "WP"
' resto in ascolto
	myTimer.Initialize("tim",1)
	myTimer.Enabled = True' azione
'Azione	
	Select Case myAction
' salvataggio preferenze
	Case "Preferences"
		myHud.ProgressDialogShow("Attendere prego ...")
		Dim myFTP As FTP
		myFTP.Initialize("FTP",server,port,user,password)
		myFTP.List(ftppath)
	Case "Connect"
		myHud.ProgressDialogShow("Attendere prego ...")
		Dim myFTP As FTP
		myFTP.Initialize("FTP",server,port,user,password)
		myFTP.List(ftppath)	
	Case "DownloadDEFS"
		Dim myFTP As FTP
		myFTP.Initialize("FTP",server,port,user,password)
		myFTP.List("/DEFS/")		
	Case "DownloadOUT"
		myAction = "Download"
		Dim myFTP As FTP
		myFTP.Initialize("FTP",server,port,user,password)
		myFTP.List("/AGENTI/" & Globals.age & "/OUT/")
	End Select
	
End Sub

Sub CreateFolders(age As String)

	myNrCommands = 3
	
	myFTP.SendCommand("MKD", "/AGENTI/" & age )
	myFTP.SendCommand("MKD", "/AGENTI/" & age & "/IN")
	myFTP.SendCommand("MKD", "/AGENTI/" & age & "/OUT") 
	
End Sub	

Sub ftp_ListCompleted (ServerPath As String, Success As Boolean, Folders() As FTPEntry, Files() As FTPEntry)
	If Success Then
		Select Case myAction
		Case "Preferences"		
			CreateFolders(Globals.age)
		Case "Connect"
			ftpStatus = "SI"
		Case "Download"
			ftpJobs.Initialize
			For i = 0 To Files.Length - 1        
        		ftpJobs.add(Files(i).Name)
			Next
			If ftpJobs.Size = 0 Then
				ftpStatus = "NF"	
			Else
				myHud.ProgressDialogShow("Scarico del file " & ftpJobs.Get(0))
				myFTP.DownloadFile("/AGENTI/" & Globals.age & "/OUT/" & ftpJobs.Get(0), False, File.DirDocuments, "/IN/" & ftpJobs.get(0))
			End If		
		Case "DownloadDEFS"
			ftpJobs.Initialize
			For i = 0 To Files.Length - 1        
        		ftpJobs.add(Files(i).Name)
			Next
			If ftpJobs.Size = 0 Then
				ftpStatus = "NF"	
			Else
				If File.Exists(File.DirDocuments & "/DEFS/",ftpJobs.Get(0)) Then
					File.Delete(File.DirDocuments & "/DEFS/",ftpJobs.Get(0))
				End If
				myHud.ProgressDialogShow("Scarico del file " & ftpJobs.Get(0)) 	
				myFTP.DownloadFile("/DEFS/" & ftpJobs.Get(0), False, File.DirDocuments, "/DEFS/" & ftpJobs.get(0))
			End If
		End Select
	Else
		ftpStatus = "NO"
	End If
End Sub

Sub ftp_CommandCompleted (Command As String, Success As Boolean, ReplyCode As Int, ReplyString As String)
	myCounter = myCounter + 1
	If myCounter = myNrCommands Then 
		ftpStatus = "SI"
	End If
End Sub

Sub FTP_DownloadProgress (ServerPath As String, TotalDownloaded As Long, Total As Long)

End Sub
	
Sub FTP_DownloadCompleted (ServerPath As String, Success As Boolean)	
	Select Case myAction
	Case "Download"
		If (ftpJobs.Size-1) > 0 Then
			ftpJobs.RemoveAt(0)
			myHud.ProgressDialogShow("Scarico del file " & ftpJobs.Get(0)) 	
			myFTP.DownloadFile("/AGENTI/" & Globals.age & "/OUT/" & ftpJobs.Get(0), False, File.DirDocuments, "/IN/" & ftpJobs.get(0))	
		Else
			ftpStatus = "SI"
		End If
	Case "DownloadDEFS"
		If (ftpJobs.Size-1) > 0 Then
			ftpJobs.RemoveAt(0)
			myHud.ProgressDialogShow("Scarico del file " & ftpJobs.Get(0)) 	
			myFTP.DownloadFile("/DEFS/" & ftpJobs.Get(0), False, File.DirDocuments, "/DEFS/" & ftpJobs.get(0))	
		Else
			myAction = "Download"
			myFTP.List("/AGENTI/" & Globals.age & "/OUT/") 
		End If
	End Select
End Sub

Sub tim_tick			
	Select Case ftpStatus
	Case "WP"
		myTimer.Initialize("tim",1)
		myTimer.Enabled = True
	Case "SI" 
		myTimer.Enabled = False
		myHud.ProgressDialogHide
		Select Case myAction
		Case "Preferences"
			Globals.myMenu.Initialize("MainMenu")
			Main.NavControl.ShowPage(Globals.myMenu.myPage)
		Case "Connect"
			Msgbox("Collegamento riuscito con successo","Server FTP")
		Case "Download"
			Msgbox("Scarico files riuscito con successo","Server FTP")
		End Select
	Case "NF"
		myTimer.Enabled = False
		myHud.ProgressDialogHide
		Msgbox("Non trovati file da scaricare.","Server FTP")		
	Case "NO"
		myTimer.Enabled = False
		Msgbox("Errori riscontrati nelle operazioni FTP, dati di login non esatti.","Errore FTP")
	End Select
End Sub
